import 'dart:convert';
import 'dart:io';

void main(List<String> arguments) {
  var file = File(arguments.first);

  if (!file.existsSync()) {
    print('Cannot find the file "${arguments.first}".');
  }

  var content = file.readAsStringSync();
  Map<String, dynamic> iconfont = json.decode(content);
  List<dynamic> icons = iconfont['glyphs'];
  Map<String, String> iconDefinitions = {};

  icons.forEach((icon) {
    var iconName = icon['font_class'];
    iconDefinitions[iconName] = generateExampleIcon(iconName);
  });

  List<String> generatedOutput = [
    '',
    "import 'package:don_icons/don_icons.dart';",
    "import 'package:don_icons_example/example_icon.dart';",
    '',
    '// THIS FILE IS AUTOMATICALLY GENERATED!',
    '',
    'final icons = <ExampleIcon>[',
  ];

  generatedOutput.addAll(iconDefinitions.values);

  generatedOutput.add('];');

  File output = File('example/lib/icons.dart');
  output.writeAsStringSync(generatedOutput.join('\n'));
}

String generateExampleIcon(String iconName) {
  iconName = iconName.replaceAll('-', '_');
  return "ExampleIcon(DonIcons.$iconName, '$iconName'),";
}
